/* $Id: pim_var.h,v 1.10 2000/03/08 09:13:18 pavlin Exp $ */

#ifndef _NETINET_PIM_VAR_H_
#define _NETINET_PIM_VAR_H_

/*
 * Protocol Independent Multicast (PIM),
 * implementation-specific definitions.
 *
 * Written by George Edmond Eddy (Rusty), ISI, February 1998
 * Modified by Pavlin Ivanov Radoslavov, USC/ISI, May 1998, Aug 1999
 * Modified by Hitoshi Asaeda, WIDE, August 1998
 */

struct pimstat {
    u_long	pims_rcv_total_msgs;	/* total PIM messages received	*/
    u_long	pims_rcv_total_bytes;	/* total PIM bytes received	*/
    u_long	pims_rcv_tooshort;	/* received with too few bytes	*/
    u_long	pims_rcv_badsum;	/* received with bad checksum	*/
    u_long	pims_rcv_badversion;	/* received bad PIM version	*/
    u_long	pims_rcv_registers_msgs;  /* received regs. msgs (data only) */
    u_long	pims_rcv_registers_bytes; /* received regs. bytes (data only)*/
    u_long	pims_rcv_badregisters;	  /* received invalid registers	     */
    u_long	pims_snd_registers_msgs;  /* sent regs. messages (data only) */
    u_long	pims_snd_registers_bytes; /* sent regs. bytes (data only)    */
    u_long	pims_registers_wrongiif;  /* registers rcvd on native (S,G)  */
};

#ifndef __P
#ifdef __STDC__
#define __P(x)  x
#else
#define __P(x)  ()
#endif
#endif

#if (defined(KERNEL)) || (defined(_KERNEL))
extern struct pimstat pimstat;

#ifdef NetBSD
void pim_input __P((struct mbuf *, ...));
#else
void pim_input __P((struct mbuf *, int));
#endif
#endif /* KERNEL */

/*
 * Names for PIM sysctl objects
 */
#if (defined(__FreeBSD__)) || (defined(NetBSD)) || (defined(__bsdi__))
#define PIMCTL_STATS		1	/* statistics (read-only) */
#define PIMCTL_MAXID		2

#define PIMCTL_NAMES { \
	{ 0, 0 }, \
	{ "stats", CTLTYPE_STRUCT }, \
}
#endif /* FreeBSD || NetBSD || bsdi */

#if (defined(__FreeBSD__) && (__FreeBSD_version >= 400000))
#if defined(KERNEL) && defined(SYSCTL_DECL)
SYSCTL_DECL(_net_inet_pim);
#endif
#endif /* FreeBSD >= 4.0 */

#if (defined(__bsdi__) || defined(NetBSD))
#define PIMCTL_VARS { \
	0, \
	0, \
}
int	pim_sysctl __P((int *, u_int, void *, size_t *, void *, size_t));
#endif /* bsdi || NetBSD */

#endif /* _NETINET_PIM_VAR_H_ */

